# This script starts Linux driver installation
#
DIR=./Sentinel

trap ":" 0 1 2 3

# Installing the Sentinel Unix Driver
uname -r | grep '2\.2\.' > /dev/null 2>&1
if [ $? = 0 ]
then
    opt=63
    version=v2.2
fi

go_out()
{
    echo This Kernel Version is not supported.
    exit 1
}

getversion()
{

opt=63
uname -a | grep "SMP" > /dev/null 2>&1
if [ $? = 0 ]
then
   cpu=smp
fi

ver1=`uname -r | cut -d. -f 1`
ver2=`uname -r | cut -d. -f 2`
ver3=`uname -r | cut -d. -f 3|cut -d- -f 1`
uname -r |grep "-" > /dev/null 2>&1
if [ $? = 0 ]
then
    uname -r |grep "smp" > /dev/null 2>&1
    if [ $? = 0 ]
    then
	rev=`uname -r | cut -d. -f 3|cut -d- -f 2|cut -ds -f1`
    else
	rev=`uname -r | cut -d. -f 3|cut -d- -f 2`
    fi
else
    rev=0
fi

#echo KERNEL $ver1 $ver2 $ver3 $rev

chk=$((($ver1==2) && ($ver2==4) && ($ver3>=7)))  
if [ $chk = 0 ] 
then
    go_out
fi

chk=$((($ver3==7)))  
if [ $chk = 1 ] 
then
    chk1=$((($rev<10)))  
    if [ $chk1 = 1 ] 
    then
	go_out
    fi
    version=v2.4$cpu/2.4.7
fi

chk=$((($ver3<18)))  
if [ $chk = 1 ] 
then
    version=v2.4$cpu/2.4.7
fi

chk=$((($ver3==18)))  
if [ $chk = 1 ] 
then

    chk1=$(($rev<3))  
    if [ $chk1 = 1 ] 
    then    
	version=v2.4$cpu/2.4.7
    fi

    chk1=$((($rev>=3) && ($rev <14)))
    if [ $chk1 = 1 ] 
    then    
	version=v2.4$cpu/2.4.18-3
    fi

    chk1=$(($rev>=14))  
    if [ $chk1 = 1 ] 
    then    
	version=v2.4$cpu/2.4.18-14
    fi
    
fi

chk=$((($ver3>=20)))
if [ $chk = 1 ]
then
    version=v2.4$cpu/2.4.20-8
fi

#chk=$((($ver3>18)))  
#if [ $chk = 1 ] 
#then
#    version=v2.4$cpu/2.4.18-14
#fi

}

CreateDev() { #create rainbow devices
   set 0 1 2 3
   for i in rnbodrv0 rnbodrv1 rnbodrv2 rnbodrv3;do
   (cd /dev; mknod $i- c $opt $1; chown root:sys $i-; chmod 666 $i-; mv $i- $i)
   shift
   done
}

   if [ ! -f /etc/rc.d/rc.local ]
   then
      echo "#!/bin/sh" > /etc/rc.d/rc.local
      chmod 755 /etc/rc.d/rc.local
      chown root root /etc/rc.d/rc.local
   fi

#get version
getversion

echo 	Installing driver for "$version" kernel.

   cp $DIR/$version/mdrbdr.o /opt/RainbowTechnologies/SUD5.50/Parallel/.  > /dev/null 2>&1

   grep mdrbdr.o /etc/rc.d/rc.local > /dev/null 2>&1
   if [ $? != 0 ]
   then
      cp /etc/rc.d/rc.local /etc/rc.d/rc.local.old > /dev/null 2>&1
      echo "# Sentinel Unix Driver" >> /etc/rc.d/rc.local
      echo "# SUD550: To specify your own parallel port use the following" >> /etc/rc.d/rc.local
      echo "# insmod -f /opt/RainbowTechnologies/SUD5.50/Parallel/mdrbdr.o address=<address of port>" >> /etc/rc.d/rc.local
      echo "/sbin/insmod -f /opt/RainbowTechnologies/SUD5.50/Parallel/mdrbdr.o" >> /etc/rc.d/rc.local
   fi
   /sbin/insmod -f /opt/RainbowTechnologies/SUD5.50/Parallel/mdrbdr.o > /dev/null 2>&1
   if [ $? != 0 ]
   then
      /sbin/rmmod mdrbdr > /dev/null 2>&1
      if [ $? != 0 ]
      then
         echo "Cannot uninstall a module with the same name OR Parallel port not accessible."
	 echo "Installation failed."
	    rm -rf /opt/RainbowTechnologies/SUD5.50/Parallel > /dev/null 2>&1
	    rm -rf /Sentinel/ > /dev/null 2>&1

	    (rm -rf /tmp/x;grep "mdrbdr.o" /etc/rc.d/rc.local > /dev/null )
	    (rm -rf /tmp/x;echo "/Sentinel/" > RBEOF)
	    (rm -rf /tmp/x;echo "d" >> RBEOF ; echo "w" >> RBEOF ; echo "q" >> RBEOF)
	    (rm -rf /tmp/x;grep "Sentinel" /etc/rc.d/rc.local && ed /etc/rc.d/rc.local < RBEOF)>/dev/null 2>&1
	    (rm -rf /tmp/x;echo "/SUD550:/" > RBEOF)
	    (rm -rf /tmp/x;echo "d" >> RBEOF ; echo "w" >> RBEOF ; echo "q" >> RBEOF)
	    (rm -rf /tmp/x;grep "SUD550:" /etc/rc.d/rc.local && ed /etc/rc.d/rc.local < RBEOF) >/dev/null 2>&1
	    (rm -rf /tmp/x;echo "/mdrbdr.o/" > RBEOF)
	    (rm -rf /tmp/x;echo "d" >> RBEOF ; echo "w" >> RBEOF ; echo "q" >> RBEOF)
	    (rm -rf /tmp/x;grep "mdrbdr.o" /etc/rc.d/rc.local && ed /etc/rc.d/rc.local < RBEOF) >/dev/null 2>&1
	    (rm -rf /tmp/x;grep "mdrbdr.o" /etc/rc.d/rc.local && ed /etc/rc.d/rc.local < RBEOF) >/dev/null 2>&1

	    (rm -rf RBEOF)
	    exit 1
      fi
      /sbin/insmod -f /opt/RainbowTechnologies/SUD5.50/Parallel/mdrbdr.o
      if [ $? != 0 ]
      then
         echo "Cannot load driver. Installation failed."
	 rm -rf /Sentinel/ > /dev/null 2>&1
         rm -rf /opt/RainbowTechnologies/SUD5.50/Parallel > /dev/null 2>&1
         exit 1
      fi
    fi
   CreateDev
   rm -rf /Sentinel/ > /dev/null 2>&1
   exit 0





